Template Numerical Library: TNL::Solvers::Linear::Jacobi< Matrix > Class Template Reference

Template Numerical Library version\ main:0b2c40fb1

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
TNL::Solvers::Linear::Jacobi< Matrix > Class Template Reference

Iterative solver of linear systems based on the Jacobi method. More...

`#include <TNL/Solvers/Linear/Jacobi.h>`

Inheritance diagram for TNL::Solvers::Linear::Jacobi< Matrix >:
[legend]
Collaboration diagram for TNL::Solvers::Linear::Jacobi< Matrix >:
[legend]

## Public Types
using | ConstVectorViewType = typename Base::ConstVectorViewType
| Type for constant vector view.
using | DeviceType = typename Base::DeviceType
| Device where the solver will run on and auxiliary data will alloacted on.
using | IndexType = typename Base::IndexType
| Type for indexing.
using | RealType = typename Base::RealType
| Floating point type used for computations.
using | VectorViewType = typename Base::VectorViewType
| Type for vector view.
Public Types inherited from TNL::Solvers::Linear::LinearSolver< Matrix >
using | ConstVectorViewType = typename Traits< Matrix >::ConstVectorViewType
| Type for constant vector view.
using | DeviceType = typename Matrix::DeviceType
| Device where the solver will run on and auxiliary data will alloacted on.
using | IndexType = typename Matrix::IndexType
| Type for indexing.
using | MatrixPointer = std::shared_ptr< std::add_const_t< MatrixType > >
| Type of shared pointer to the matrix.
using | MatrixType = Matrix
| Type of the matrix representing the linear system.
using | PreconditionerPointer = std::shared_ptr< std::add_const_t< PreconditionerType > >
| Type of shared pointer to the preconditioner.
using | PreconditionerType = Preconditioners::Preconditioner< MatrixType >
| Type of preconditioner.
using | RealType = typename Matrix::RealType
| Floating point type used for computations.
using | VectorViewType = typename Traits< Matrix >::VectorViewType
| Type for vector view.
Public Types inherited from TNL::Solvers::IterativeSolver< Matrix::RealType, Matrix::IndexType >
using | SolverMonitorType
| Type of an object used for monitoring of the convergence.

## Public Member Functions
RealType | getOmega () const
| Getter of the relaxation parameter.
IndexType | getResiduePerid () const
| Get the period for a recomputation of the residue.
void | performIteration (const ConstVectorViewType &b, const ConstVectorViewType &diagonalView, const ConstVectorViewType &in, VectorViewType &out) const
void | setOmega (RealType omega)
| Setter of the relaxation parameter.
void | setResiduePeriod (IndexType period)
| Set the period for a recomputation of the residue.
bool | setup (const Config::ParameterContainer &parameters, const String &prefix="") override
| Method for setup of the linear iterative solver based on configuration parameters.
bool | solve (ConstVectorViewType b, VectorViewType x) override
| Method for solving of a linear system.
Public Member Functions inherited from TNL::Solvers::Linear::LinearSolver< Matrix >
virtual | ~LinearSolver ()=default
| Default destructor.
virtual void | setMatrix (const MatrixPointer &matrix)
| Set the matrix of the linear system.
void | setPreconditioner (const PreconditionerPointer &preconditioner)
| Set the preconditioner.
Public Member Functions inherited from TNL::Solvers::IterativeSolver< Matrix::RealType, Matrix::IndexType >
| IterativeSolver ()=default
| Default constructor.
virtual bool | checkConvergence () const
| Checks whether the convergence occurred already.
virtual bool | checkNextIteration () const
| Checks if the solver is allowed to do the next iteration.
const Matrix::RealType & | getConvergenceResidue () const
| Gets the threshold for convergence based on residue.
const Matrix::RealType & | getDivergenceResidue () const
| Gets the threshold for divergence based on residue.
const Matrix::IndexType & | getIterations () const
| Gets the number of iterations performed by the solver so far.
const Matrix::IndexType & | getMaxIterations () const
| Gets the maximal number of iterations the solver is allowed to perform.
const Matrix::IndexType & | getMinIterations () const
| Gets the minimal number of iterations the solver is supposed to do.
const Matrix::RealType & | getResidue () const
| Gets the residue reached at the current iteration.
virtual bool | nextIteration ()
| Proceeds to the next iteration.
void | resetIterations ()
| Sets the the number of the current iterations to zero.
void | setConvergenceResidue (const Matrix::RealType &convergenceResidue)
| Sets the threshold for convergence based on residue.
void | setDivergenceResidue (const Matrix::RealType &divergenceResidue)
| Sets the threshold for divergence based on residue.
void | setMaxIterations (const Matrix::IndexType &maxIterations)
| Sets the maximal number of iterations the solver is allowed to perform.
void | setMinIterations (const Matrix::IndexType &minIterations)
| Sets the minimal number of iterations the solver is supposed to do.
void | setRefreshRate (const Matrix::IndexType &refreshRate)
| Sets the refresh rate (in milliseconds) for the solver monitor.
void | setResidue (const Matrix::RealType &residue)
| Sets the residue reached at the current iteration.
void | setSolverMonitor (SolverMonitorType &solverMonitor)
| Sets the solver monitor object.
bool | setup (const Config::ParameterContainer &parameters, const std::string &prefix="")
| Method for setup of the iterative solver based on configuration parameters.

## Static Public Member Functions
static void | configSetup (Config::ConfigDescription &config, const String &prefix="")
| This is method defines configuration entries for setup of the linear iterative solver.
Static Public Member Functions inherited from TNL::Solvers::Linear::LinearSolver< Matrix >
static void | configSetup (Config::ConfigDescription &config, const String &prefix="")
| This method defines configuration entries for setup of the linear iterative solver.
Static Public Member Functions inherited from TNL::Solvers::IterativeSolver< Matrix::RealType, Matrix::IndexType >
static void | configSetup (Config::ConfigDescription &config, const std::string &prefix="")
| This method defines configuration entries for setup of the iterative solver.

## Protected Attributes
VectorType | diagonal
RealType | omega = 1.0
IndexType | residuePeriod = 4
Protected Attributes inherited from TNL::Solvers::Linear::LinearSolver< Matrix >
MatrixPointer | matrix = nullptr
PreconditionerPointer | preconditioner = nullptr
Protected Attributes inherited from TNL::Solvers::IterativeSolver< Matrix::RealType, Matrix::IndexType >
Matrix::RealType | convergenceResidue
Matrix::IndexType | currentIteration
Matrix::RealType | currentResidue
Matrix::RealType | divergenceResidue
Matrix::IndexType | maxIterations
Matrix::IndexType | minIterations
Matrix::IndexType | refreshRate
std::ofstream | residualHistoryFile
std::string | residualHistoryFileName
IterativeSolverMonitor< double > * | solverMonitor

## Detailed Description

template<typename Matrix>
class TNL::Solvers::Linear::Jacobi< Matrix >

Iterative solver of linear systems based on the Jacobi method.

See Wikipedia for more details.

See TNL::Solvers::Linear::LinearSolver for example of showing how to use the linear solvers.

Template Parameters

  Matrix | is type of matrix describing the linear system.

## Member Function Documentation

## ◆ configSetup()

template<typename Matrix>

void TNL::Solvers::Linear::Jacobi< Matrix >::configSetup | ( | Config::ConfigDescription & | config,
|  | const String & | prefix = "" )
| static

This is method defines configuration entries for setup of the linear iterative solver.

In addition to config entries defined by IterativeSolver::configSetup, this method defines the following:

jacobi-omega - relaxation parameter of the weighted/damped Jacobi method - 1.0 by default. residue-period - number of iterations between subsequent recomputations of the residue - 4 by default.

Parameters

  config | contains description of configuration parameters.
  prefix | is a prefix of particular configuration entries.

## ◆ getOmega()

template<typename Matrix>

RealType TNL::Solvers::Linear::Jacobi< Matrix >::getOmega | ( |  | ) | const
| nodiscard

Getter of the relaxation parameter.

Returns
  value of the relaxation parameter.

## ◆ getResiduePerid()

template<typename Matrix>

IndexType TNL::Solvers::Linear::Jacobi< Matrix >::getResiduePerid | ( |  | ) | const
| nodiscard

Get the period for a recomputation of the residue.

Returns
  number of iterations between subsequent recomputations of the residue.

## ◆ setOmega()

template<typename Matrix>

void TNL::Solvers::Linear::Jacobi< Matrix >::setOmega | ( | RealType | omega | ) |

Setter of the relaxation parameter.

Parameters

  omega | the relaxation parameter. It is 1 by default.

## ◆ setResiduePeriod()

template<typename Matrix>

void TNL::Solvers::Linear::Jacobi< Matrix >::setResiduePeriod | ( | IndexType | period | ) |

Set the period for a recomputation of the residue.

Parameters

  period | number of iterations between subsequent recomputations of the residue.

## ◆ setup()

template<typename Matrix>

bool TNL::Solvers::Linear::Jacobi< Matrix >::setup | ( | const Config::ParameterContainer & | parameters,
|  | const String & | prefix = "" )
| overridevirtual

Method for setup of the linear iterative solver based on configuration parameters.

Parameters

  parameters | contains values of the define configuration entries.
  prefix | is a prefix of particular configuration entries.

Reimplemented from TNL::Solvers::Linear::LinearSolver< Matrix >.

## ◆ solve()

template<typename Matrix>

bool TNL::Solvers::Linear::Jacobi< Matrix >::solve | ( | ConstVectorViewType | b,
|  | VectorViewType | x )
| overridevirtual

Method for solving of a linear system.

See LinearSolver::solve for more details.

Parameters

  b | vector with the right-hand side of the linear system.
  x | vector for the solution of the linear system.

Returns
  true if the solver converged.
  false if the solver did not converge.

Implements TNL::Solvers::Linear::LinearSolver< Matrix >.

The documentation for this class was generated from the following file:

- src/TNL/Solvers/Linear/Jacobi.h